﻿//==================================================================================
// Prototypes for Macromedia Flash 8
// Simon Coulton - April 2006 - Taken from http://proto.layer51.com/
// include #thisfile.as
//==================================================================================
/* Timer Class v1.0
   by Jonas Galvez (jonas@onrelease.org)

 Methods: start, stop, pause
 Events: onTimerStatus, onTimerFinish
 Usage: var someTimer = new Timer(10); // 10 seconds

        someTimer.onTimerStatus = function(status) {
        	  _root.tf.text = status;
 		  };

        someTimer.start(); */
_global.Timer = function(seconds) {
	this._seconds = seconds;
	this._listeners = [];
	this._status = function() {
		var final_t = this._final.getTime();
		var current_t = new Date().getTime();
		if ((this._status=final_t-current_t)<=0) {
			this._finish();
		} else {
			this.broadcastMessage("onTimerStatus", this._status);
		}
	};
	var final_t = (this._final=new Date()).getMilliseconds();
	this._final.setMilliseconds(final_t+(seconds*1000));
	this.addListener(this);
};
Timer.prototype.start = function() {
	this._finish = function() {
		this.broadcastMessage("onTimerStatus", 0);
		this.broadcastMessage("onTimerFinish");
		clearInterval(this._idstatus);
	};
	this._idstatus = setInterval(this, "_status", 50);
};
Timer.prototype.stop = function() {
	clearInterval(this._idstatus);
};
Timer.prototype.pause = function(seconds) {
	if (seconds != null) {
		clearInterval(this._idstatus);
		var pause_id = setInterval(function (o) {
			o.start();
			clearInterval(pause_id);
		}, seconds*1000, this);
	}
};
ASBroadcaster.initialize(Timer.prototype);
ASSetPropFlags(_global, "Timer", 1);
/* Color - Tint
   by Robert Penner
   
   Methods: setTint(r,g,b,amount); - r, g, b between 0 and 255; amount between 0 and 100
   Usage: var myColor = new Color(mc);
  myColor.setTint(50,50,50,100);
*/
Color.prototype.setTint = function(r, g, b, amount) {
	var percent = 100-amount;
	var trans = new Object();
	trans.ra = trans.ga=trans.ba=percent;
	var ratio = amount/100;
	trans.rb = r*ratio;
	trans.gb = g*ratio;
	trans.bb = b*ratio;
	this.setTransform(trans);
};
/* toBool
   by black
   Description:    A convenient way to get boolean value of anything you passed.
                   The corresponding boolean value will be returned.
   Usage: something  = 1;
          nothing = "";
          bool_1 = toBool(something);
          bool_2 = toBool(nothing);
          // Output will be first a true and second a false~
          trace(bool_1);
          trace(bool_2);
*/
function toBool(anything) {
	return !(!anything);
}
/* Email Address Validation
   Methods: isEmail
   Usage: var myStr = new String("my@email.com");
          myStr.isEmail();
*/
String.prototype.isEmail = function() {
	if (this.length<5) {
		//email address has to have at least 5 chars
		return false;
	}
	var iChars = "*|,\":<>[]{}`';()&$#%";
	var eLength = this.length;
	for (var i = 0; i<eLength; i++) {
		if (iChars.indexOf(this.charAt(i)) != -1) {
			trace("Invalid Email Address : Illegal Character in Email Address : -->"+this.charAt(i)+"<--.");
			return false;
		}
	}
	var atIndex = this.lastIndexOf("@");
	if (atIndex<1 || (atIndex == eLength-1)) {
		trace("Invalid Email Address : Email Address must contain @ as at least the second chararcter.");
		return false;
	}
	var pIndex = this.lastIndexOf(".");
	if (pIndex<4 || (pIndex == eLength-1)) {
		trace("Invalid Email Address : Email Address must contain at least one . (period) in a valid position");
		return false;
	}
	if (atIndex>pIndex) {
		this.__error = "Invalid Email Address : Email Address must be in the form of name@domain.domaintype";
		return false;
	}
	for (var i = 0; i<eLength; i++) {
		if ((this.charAt(i) == "." || this.charAt(i) == "@") && this.charAt(i) == this.charAt(i-1)) {
			trace("Invalid Email Address : Cannot contain two \".\" or \"@\" in a row : -->"+this.charAt(i)+"<--.");
			return false;
		}
	}
	return true;
};
/* Popup Window (HTML)
   by adrien
   
   Usage: newWin('url', 500, 500, 10, 10, "Popup test");
*/
Movieclip.prototype.newWin = function(url, width, height, xPos, yPos, name) {
	if (url.substr(0, 4) != "http") {
		url = "http://"+url;
	}
	getURL("javascript:window.open('"+url+"','"+name+"','width="+width+",height="+height+",screenX="+xPos+",screenY="+yPos+",left="+xPos+",top="+yPos+",scrollbars=auto');void(0);");
};
/* Flash 8 Detection
   by Simon Coulton
   
   Usage: isFlashEight() - returns true/false
*/
function isFlashEight() {
	var my_str:String = new String(System.capabilities.version);
	if (my_str.slice(-8) != '8,0,22,0') {
		return false;
	}
	return true;
}
/* Output to Java Window
   Usage: tracer( "i am a debug-window" );
*/
_global.dumpInit = function() {
	if (System.capabilities.playerType == 'PlugIn') {
		_global.DUMP_INIT = true;
		_global.DUMPCOUNTER_SINGLE = 1;
		getURL("Javascript:dump_win=window.open('','singledump','width=500, height=600, scrollbars=yes,scrolling=yes,resizable,status=yes');void(0);dump_win.focus();");
		getURL("Javascript:dump_win.document.write('<HTML><HEAD><TITLE>T R A C E R</TITLE>');");
		getURL("Javascript:dump_win.document.write('<STYLE TYPE=\"text/css\"><!--');");
		getURL("Javascript:dump_win.document.write('PRE{font-weight:normal;font-size:11px;color:#333333;}');");
		getURL("Javascript:dump_win.document.write('A{font-weight:bold;font-size:11px;color:#999999}');");
		getURL("Javascript:dump_win.document.write('A#comment{font-weight:normal;font-size:11px;color:#FF0000;}');");
		getURL("Javascript:dump_win.document.write('--></STYLE>');");
		getURL("Javascript:dump_win.document.write('</HEAD><BODY BGCOLOR=\"#EFEFEF\"><PRE>');");
	}
};
_global.tracer = function(dumpString_) {
	if (System.capabilities.playerType == 'PlugIn') {
		if (_global.DUMP_INIT == undefined) {
			_global.dumpInit();
		}
		getURL("Javascript:if(dump_win.closed == true){dump_win=window.open('','singledump','width=500, height=600, scrollbars=yes,scrolling=yes,resizable,status=yes');void(0);dump_win.focus();dump_win.document.write('<HTML><HEAD><TITLE>T R A C E R </TITLE></HEAD><BODY BGCOLOR=\"#EFEFEF\"><PRE>');};");
		var lineNumberString = _global.DUMPCOUNTER_SINGLE++;
		while (lineNumberString.length<4) {
			lineNumberString += " ";
		}
		lineNumberString = "<A>"+lineNumberString+"> </A>";
		if (dumpString_ == "##") {
			dumpString_ = "<A ID=\"comment\">#########################################################</A>";
		}
		getURL("Javascript:dump_win.document.write('"+lineNumberString+dumpString_+"<BR>');dump_win.focus();");
	}
};

/* Mouse Follow
   Method: setMousefollow(speed);
   Usage: this.maus_mc.setMousefollow(15);
*/

MovieClip.prototype.setMousefollow = function (speed)
{
	this.onEnterFrame = function ()
	{
		this._x += (_xmouse - this._x) / speed;
		this._y += (_ymouse - this._y) / speed;
	};
};

/* Double Click 
   Method: _onDoubleClick
   Usage: function sampleFunction(str:String):Void {
			trace(str);
			}
		  test._onDoubleClick(sampleFunction, "helloWorld");
*/

MovieClip.prototype._onDoubleClick = function(func:Function, arg:Object) {
	var clickInterval:Number = 20;
	var counter:Number = 0;
	var lastCounter:Number = 0;
	var intervalID:Number;
	
	this.onPress = function() {
		if(counter != lastCounter) {
			if ((counter-lastCounter)<clickInterval) {
				func(arg);
				clearInterval(intervalID);
				counter = 0;
				lastCounter = 0;
			}
		} else {
			intervalID = setInterval(counterPlus, 10);
		}
		
		lastCounter = counter;
	};
	
	function counterPlus() {
		counter++;
		if(counter>clickInterval) {
			clearInterval(intervalID);
			counter = 0;
			lastCounter = 0;
		}
	}
};

// Maths Functions
Number.prototype.isEven = function () {
	return !(this % 2);
}
Number.prototype.isMultipleOf = function (iBase) {
	return (this % iBase == 0);
}
/* Smooth Dragging Replacement
   by senocular
   Methods: beginDrag, endDrag
   
   Usage: on(press){
			this.beginDrag(true,0,0,300,300); // constrained to 300x300 square
		  }
		  on(release, releaseOutside){
			this.endDrag();
		  }
*/
MovieClip.prototype.beginDrag = function(target, lock, l, t, r, b){
	if (typeof target == "string"){
		target = eval(target);
		if (!target) return trace("Warning: Invalid MovieClip for beginDrag. "+target);
	}else if (!(target instanceof MovieClip)){
		b=r; r=t; t=l; l=lock; lock=target; target=this;
	}
	if (target.$dragMethod) target.endDrag();
	target.$dragMethod = {MM:target.onMouseMove};
	ASSetPropFlags(target,"$dragMethod",1,1);
	target.addProperty("onMouseMove",arguments.callee.getMM,arguments.callee.setMM);
	ASSetPropFlags(target,"onMouseMove",3);
	var constrain = (arguments.length > 1);
	var off_x = 0, off_y = 0;
	if (!lock){
		off_x = target._parent._xmouse-target._x;
		off_y = target._parent._ymouse-target._y;
	}
	target.$dragMethod.drag = function(){
		target._x = target._parent._xmouse-off_x;
		target._y = target._parent._ymouse-off_y;
		if (constrain){
			if (typeof l == "object"){
				t = l.ymin;
				r = l.xmax;
				b = l.ymax;
				l = l.xmin;
			}
			if (target._x < l) target._x = l;
			else if (target._x > r) target._x = r;
			if (target._y < t) target._y = t;
			else if (target._y > b) target._y = b;
		}
		updateAfterEvent();
	}
}
MovieClip.prototype.beginDrag.getMM = function(){
	this.$dragMethod.drag();
	return this.$dragMethod.MM;
}
MovieClip.prototype.beginDrag.setMM = function(f){
	this.$dragMethod.MM = f;
}				  
MovieClip.prototype.endDrag = function(target){
	if (arguments.length){
		if (typeof target == "string") target = eval(target);
		if (!target) return trace("Warning: Invalid MovieClip for beginDrag. "+target);
	}else target = this;
	ASSetPropFlags(target,"onMouseMove",0,3);
	delete target.onMouseMove;
	if (target.$dragMethod.MM) target.onMouseMove = target.$dragMethod.MM;
	delete target.$dragMethod;
	target.startDrag(); // for _droptarget
	target.stopDrag();
}
